<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "page".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Page".
 *
 * Columns in table "page" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property integer $meta_noindex
 * @property string $friendly_url
 * @property string $title
 * @property string $meta_description
 * @property string $meta_keywords
 * @property string $meta_robots
 * @property string $head_tags
 * @property string $headline
 * @property string $sub_headline
 * @property string $body
 *
 */
abstract class BasePage extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'page';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Page|Pages', $n);
    }

    public static function representingColumn()
    {
        return 'friendly_url';
    }

    public function rules()
    {
        return array(
            array('friendly_url, title, body', 'required'),
            array('meta_noindex', 'numerical', 'integerOnly' => true),
            array('friendly_url', 'unique'),
            array('friendly_url, title, meta_robots', 'length', 'max' => 255),
            array('meta_description, meta_keywords, head_tags, headline, sub_headline', 'safe'),
            array('meta_noindex, meta_description, meta_keywords, meta_robots, head_tags, headline, sub_headline', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, meta_noindex, friendly_url, title, meta_description, meta_keywords, meta_robots, head_tags, headline, sub_headline, body', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'meta_noindex' => Yii::t('app', 'Meta Noindex'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'title' => Yii::t('app', 'Title'),
            'meta_description' => Yii::t('app', 'Meta Description'),
            'meta_keywords' => Yii::t('app', 'Meta Keywords'),
            'meta_robots' => Yii::t('app', 'Meta Robots'),
            'head_tags' => Yii::t('app', 'Head Tags'),
            'headline' => Yii::t('app', 'Headline'),
            'sub_headline' => Yii::t('app', 'Sub Headline'),
            'body' => Yii::t('app', 'Body'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('meta_noindex', $this->meta_noindex);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('meta_description', $this->meta_description, true);
        $criteria->compare('meta_keywords', $this->meta_keywords, true);
        $criteria->compare('meta_robots', $this->meta_robots, true);
        $criteria->compare('head_tags', $this->head_tags, true);
        $criteria->compare('headline', $this->headline, true);
        $criteria->compare('sub_headline', $this->sub_headline, true);
        $criteria->compare('body', $this->body, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
